Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.jboss.aop.instrument
Class JoinpointClassifier

    java.lang.Object
      org.jboss.aop.instrument.JoinpointClassifier

Direct Known Subclasses:
  JoinpointFullClassifier, JoinpointSimpleClassifier

public abstract class JoinpointClassifier
extends Object

This class performs the joinpoint classifications. It is responsible for classifying a joinpoint into:

- NOT_INSTRUMENTED: the joinpoint mustn't be instrumented.
- PREPARED: means that the joinpoint containing class must be instrumented (class signature change) before it gets loaded. This step makes the runtime wrapping instrumentation feasible.
- WRAPPED: the joinpoint must be submitted to wrapping instrumentation, i.e., it must be wrapped inside a block code responsible for intercepting the joinpoint.
- DYNAMICALY_WRAPPED: equivalent to the previous one, except that this classification indicates the joinpoint will be wrapped due only to bindings added dynamicaly..

Author:
  Flavia Rainone
See Also:
  `JoinpointClassification`

Nested Class Summary
`protected static interface` | `JoinpointClassifier.Matcher` This interface encapsulates a matching method.

Constructor Summary
`JoinpointClassifier()`

Method Summary
`JoinpointClassification` | `classifyConstructorExecution(javassist.CtConstructor cons, Advisor advisor)` Classifies the execution of `cons`.
`JoinpointClassification` | `classifyFieldGet(javassist.CtField field, Advisor advisor)` Classifies the reading of `field` value.
`JoinpointClassification` | `classifyFieldSet(javassist.CtField field, Advisor advisor)` Classifies the writing of `field` value.
`protected abstract JoinpointClassification` | `classifyJoinpoint(javassist.CtMember member, Advisor advisor, JoinpointClassifier.Matcher joinpointMatcher)` Classifies a joinpoint.
`JoinpointClassification` | `classifyMethodExecution(javassist.CtMethod method, Advisor advisor)` Classifies the execution of `method`.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### JoinpointClassifier

    public JoinpointClassifier()

Method Detail

### classifyJoinpoint

    protected abstract JoinpointClassification classifyJoinpoint(javassist.CtMember member,
                                                                 Advisor advisor,
                                                                 JoinpointClassifier.Matcher joinpointMatcher)
                                                          throws javassist.NotFoundException

  Classifies a joinpoint. Subclasses must implement this method, which contains the joinpoint classification algorithm.

  Parameters:
    `member` - the member associated with the joinpoint to be classified.
    `advisor` - the advisor associated with `member` declaring class.
    `joinpointMatcher` - this matcher must be used to find out if a pointcut matches the joinpoint.
  Returns:
    the joinpoint classification.
  Throws:
    `javassist.NotFoundException` - thrown if the matching of pointcuts fails.

### classifyFieldGet

    public JoinpointClassification classifyFieldGet(javassist.CtField field,
                                                    Advisor advisor)
                                             throws javassist.NotFoundException

  Classifies the reading of `field` value.

  Parameters:
    `field` - the field whose reading joinpoint is being classified.
    `advisor` - the advisor related to the class declaring `field`.
  Returns:
    the classification of `field` read.
  Throws:
    `javassist.NotFoundException` - thrown if the matching of pointcuts fails.

### classifyFieldSet

    public JoinpointClassification classifyFieldSet(javassist.CtField field,
                                                    Advisor advisor)
                                             throws javassist.NotFoundException

  Classifies the writing of `field` value.

  Parameters:
    `field` - the field whose writing joinpoint is being classified.
    `advisor` - the advisor related to the class declaring `field`.
  Returns:
    the classification of `field` write.
  Throws:
    `javassist.NotFoundException` - thrown if the matching of pointcuts fails.

### classifyConstructorExecution

    public JoinpointClassification classifyConstructorExecution(javassist.CtConstructor cons,
                                                                Advisor advisor)
                                                         throws javassist.NotFoundException

  Classifies the execution of `cons`.

  Parameters:
    `cons` - the constructor whose execution joinpoint is being classified.
    `advisor` - the advisor related to the class declaring `cons`.
  Returns:
    the classification of `cons` execution.
  Throws:
    `javassist.NotFoundException` - thrown if the matching of pointcuts fails.

### classifyMethodExecution

    public JoinpointClassification classifyMethodExecution(javassist.CtMethod method,
                                                           Advisor advisor)
                                                    throws javassist.NotFoundException

  Classifies the execution of `method`.

  Parameters:
    `method` - the method whose execution joinpoint is being classified.
    `advisor` - the advisor related to the class declaring `method`.
  Returns:
    the classification of `method` execution.
  Throws:
    `javassist.NotFoundException` - thrown if the matching of pointcuts fails.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2004 JBoss Inc. All Rights Reserved.